Attribute VB_Name = "mod_Services"
'   Quellcode von MaG (Mario Grimm)
'   http://www.activevb.de/cgi-bin/forenarchive/forenarchive.pl?a=0&b=b&d=66344&e=0
Option Explicit

'API Constants
Public Const SERVICES_ACTIVE_DATABASE As String = "ServicesActive"
' Service Control
Public Const SERVICE_CONTROL_STOP As Long = &H1
Public Const SERVICE_CONTROL_PAUSE As Long = &H2
' Service State - for CurrentState
Public Const SERVICE_STOPPED As Long = &H1
Public Const SERVICE_START_PENDING As Long = &H2
Public Const SERVICE_STOP_PENDING As Long = &H3
Public Const SERVICE_RUNNING As Long = &H4
Public Const SERVICE_CONTINUE_PENDING As Long = &H5
Public Const SERVICE_PAUSE_PENDING As Long = &H6
Public Const SERVICE_PAUSED As Long = &H7
'Service Control Manager object specific access types
Public Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
Public Const SC_MANAGER_CONNECT As Long = &H1
Public Const SC_MANAGER_CREATE_SERVICE As Long = &H2
Public Const SC_MANAGER_ENUMERATE_SERVICE As Long = &H4
Public Const SC_MANAGER_LOCK As Long = &H8
Public Const SC_MANAGER_QUERY_LOCK_STATUS As Long = &H10
Public Const SC_MANAGER_MODIFY_BOOT_CONFIG As Long = &H20
Public Const SC_MANAGER_ALL_ACCESS As Long = ( _
                            STANDARD_RIGHTS_REQUIRED Or _
                            SC_MANAGER_CONNECT Or _
                            SC_MANAGER_CREATE_SERVICE Or _
                            SC_MANAGER_ENUMERATE_SERVICE Or _
                            SC_MANAGER_LOCK Or _
                            SC_MANAGER_QUERY_LOCK_STATUS Or _
                            SC_MANAGER_MODIFY_BOOT_CONFIG)
'Service object specific access types
Public Const SERVICE_QUERY_CONFIG As Long = &H1
Public Const SERVICE_CHANGE_CONFIG As Long = &H2
Public Const SERVICE_QUERY_STATUS As Long = &H4
Public Const SERVICE_ENUMERATE_DEPENDENTS As Long = &H8
Public Const SERVICE_START As Long = &H10
Public Const SERVICE_STOP As Long = &H20
Public Const SERVICE_PAUSE_CONTINUE As Long = &H40
Public Const SERVICE_INTERROGATE As Long = &H80
Public Const SERVICE_USER_DEFINED_CONTROL As Long = &H100
Public Const SERVICE_ALL_ACCESS As Long = ( _
                            STANDARD_RIGHTS_REQUIRED Or _
                            SERVICE_QUERY_CONFIG Or _
                            SERVICE_CHANGE_CONFIG Or _
                            SERVICE_QUERY_STATUS Or _
                            SERVICE_ENUMERATE_DEPENDENTS Or _
                            SERVICE_START Or _
                            SERVICE_STOP Or _
                            SERVICE_PAUSE_CONTINUE Or _
                            SERVICE_INTERROGATE Or _
                            SERVICE_USER_DEFINED_CONTROL)

Type SERVICE_STATUS
    dwServiceType As Long
    dwCurrentState As Long
    dwControlsAccepted As Long
    dwWin32ExitCode As Long
    dwServiceSpecificExitCode As Long
    dwCheckPoint As Long
    dwWaitHint As Long
End Type

Private Declare Function CloseServiceHandle Lib "advapi32.dll" ( _
                ByVal hSCObject As Long) As Long
                
Private Declare Function ControlService Lib "advapi32.dll" ( _
                ByVal hService As Long, _
                ByVal dwControl As Long, _
                ByRef lpServiceStatus As SERVICE_STATUS) As Long
                
Private Declare Function OpenSCManager Lib "advapi32.dll" _
                Alias "OpenSCManagerA" ( _
                ByVal lpMachineName As String, _
                ByVal lpDatabaseName As String, _
                ByVal dwDesiredAccess As Long) As Long
                
Private Declare Function OpenService Lib "advapi32.dll" _
                Alias "OpenServiceA" ( _
                ByVal hSCManager As Long, _
                ByVal lpServiceName As String, _
                ByVal dwDesiredAccess As Long) As Long
                
Private Declare Function QueryServiceStatus Lib "advapi32.dll" ( _
                ByVal hService As Long, _
                ByRef lpServiceStatus As SERVICE_STATUS) As Long
                
Private Declare Function StartService Lib "advapi32.dll" _
                Alias "StartServiceA" ( _
                ByVal hService As Long, _
                ByVal dwNumServiceArgs As Long, _
                ByVal lpServiceArgVectors As Long) As Long

Public Function ServiceStatus(ByVal ComputerName As String, _
                              ByVal ServiceName As String) As String
    Dim ServiceStat As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim hServiceStatus As Long

    ServiceStatus = ""
    hSManager = OpenSCManager(ComputerName, _
                              SERVICES_ACTIVE_DATABASE, _
                              SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, _
                               ServiceName, _
                               SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            hServiceStatus = QueryServiceStatus(hService, ServiceStat)
            If hServiceStatus <> 0 Then
                Select Case ServiceStat.dwCurrentState
                Case SERVICE_STOPPED
                    ServiceStatus = "Stopped"
                Case SERVICE_START_PENDING
                    ServiceStatus = "Start Pending"
                Case SERVICE_STOP_PENDING
                    ServiceStatus = "Stop Pending"
                Case SERVICE_RUNNING
                    ServiceStatus = "Running"
                Case SERVICE_CONTINUE_PENDING
                    ServiceStatus = "Coninue Pending"
                Case SERVICE_PAUSE_PENDING
                    ServiceStatus = "Pause Pending"
                Case SERVICE_PAUSED
                    ServiceStatus = "Paused"
                End Select
            End If
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Function

Public Sub ServicePause(ByVal ComputerName As String, _
                        ByVal ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, _
                              SERVICES_ACTIVE_DATABASE, _
                              SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, _
                               ServiceName, _
                               SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = ControlService(hService, _
                                 SERVICE_CONTROL_PAUSE, _
                                 ServiceStatus)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub

Public Sub ServiceStart(ByVal ComputerName As String, _
                        ByVal ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, _
                              SERVICES_ACTIVE_DATABASE, _
                              SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, _
                               ServiceName, _
                               SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = StartService(hService, 0, 0)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub

Public Sub ServiceStop(ByVal ComputerName As String, _
                       ByVal ServiceName As String)
    Dim ServiceStatus As SERVICE_STATUS
    Dim hSManager As Long
    Dim hService As Long
    Dim res As Long

    hSManager = OpenSCManager(ComputerName, _
                              SERVICES_ACTIVE_DATABASE, _
                              SC_MANAGER_ALL_ACCESS)
    If hSManager <> 0 Then
        hService = OpenService(hSManager, _
                               ServiceName, _
                               SERVICE_ALL_ACCESS)
        If hService <> 0 Then
            res = ControlService(hService, _
                                 SERVICE_CONTROL_STOP, _
                                 ServiceStatus)
            CloseServiceHandle hService
        End If
        CloseServiceHandle hSManager
    End If
End Sub
